------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2007-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
pragma Style_Checks ("NM32766");
with System.Address_To_Access_Conversions;

package body Qt4.Transforms is

   function initialize_QTransform
    (Storage : System.Address)
      return Internals.QTransform_Access;
   pragma Import (C, initialize_QTransform, "__QtAda_inititialize_QTransform");

   function initialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal
    (Storage : System.Address;
     H_11 : Qt4.Q_Real;
     H_12 : Qt4.Q_Real;
     H_13 : Qt4.Q_Real;
     H_21 : Qt4.Q_Real;
     H_22 : Qt4.Q_Real;
     H_23 : Qt4.Q_Real;
     H_31 : Qt4.Q_Real;
     H_32 : Qt4.Q_Real;
     H_33 : Qt4.Q_Real)
      return Internals.QTransform_Access;
   pragma Import (C, initialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal, "__QtAda_inititialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal");

   function initialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal
    (Storage : System.Address;
     H_11 : Qt4.Q_Real;
     H_12 : Qt4.Q_Real;
     H_21 : Qt4.Q_Real;
     H_22 : Qt4.Q_Real;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real)
      return Internals.QTransform_Access;
   pragma Import (C, initialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal, "__QtAda_inititialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal");

   function initialize_QTransform_QMatrixCR
    (Storage : System.Address;
     Tx : Qt4.Matrices.Internals.QMatrix_Access)
      return Internals.QTransform_Access;
   pragma Import (C, initialize_QTransform_QMatrixCR, "__QtAda_inititialize_QTransform_QMatrixCR");

   function adjust_QTransform
    (Storage : System.Address;
     From    : Internals.QTransform_Access)
       return Internals.QTransform_Access;
   pragma Import (C, adjust_QTransform, "__QtAda_adjust_QTransform");

   procedure finalize_QTransform (Object : Internals.QTransform_Access);
   pragma Import (C, finalize_QTransform, "__QtAda_finalize_QTransform");

   function QTransform_m11
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_m11, "__QtAda_QTransform_m11_Q");

   function QTransform_m12
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_m12, "__QtAda_QTransform_m12_Q");

   function QTransform_m13
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_m13, "__QtAda_QTransform_m13_Q");

   function QTransform_m21
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_m21, "__QtAda_QTransform_m21_Q");

   function QTransform_m22
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_m22, "__QtAda_QTransform_m22_Q");

   function QTransform_m23
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_m23, "__QtAda_QTransform_m23_Q");

   function QTransform_m31
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_m31, "__QtAda_QTransform_m31_Q");

   function QTransform_m32
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_m32, "__QtAda_QTransform_m32_Q");

   function QTransform_m33
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_m33, "__QtAda_QTransform_m33_Q");

   procedure QTransform_adjoint
    (Returns : Internals.QTransform_Access;
     Self : Internals.QTransform_Access);
   pragma Import (C, QTransform_adjoint, "__QtAda_QTransform_adjoint_Q");

   function QTransform_det
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_det, "__QtAda_QTransform_det_Q");

   function QTransform_determinant
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_determinant, "__QtAda_QTransform_determinant_Q");

   function QTransform_dx
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_dx, "__QtAda_QTransform_dx_Q");

   function QTransform_dy
    (Self : Internals.QTransform_Access)
       return Qt4.Q_Real;
   pragma Import (C, QTransform_dy, "__QtAda_QTransform_dy_Q");

   procedure QTransform_inverted
    (Returns : Internals.QTransform_Access;
     Self : Internals.QTransform_Access);
   pragma Import (C, QTransform_inverted, "__QtAda_QTransform_inverted_Q");

   function QTransform_isAffine
    (Self : Internals.QTransform_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QTransform_isAffine, "__QtAda_QTransform_isAffine_Q");

   function QTransform_isIdentity
    (Self : Internals.QTransform_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QTransform_isIdentity, "__QtAda_QTransform_isIdentity_Q");

   function QTransform_isInvertible
    (Self : Internals.QTransform_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QTransform_isInvertible, "__QtAda_QTransform_isInvertible_Q");

   function QTransform_isRotating
    (Self : Internals.QTransform_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QTransform_isRotating, "__QtAda_QTransform_isRotating_Q");

   function QTransform_isScaling
    (Self : Internals.QTransform_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QTransform_isScaling, "__QtAda_QTransform_isScaling_Q");

   function QTransform_isTranslating
    (Self : Internals.QTransform_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QTransform_isTranslating, "__QtAda_QTransform_isTranslating_Q");

   procedure QTransform_map_qreal_qreal_qrealP_qrealP
    (Self : Internals.QTransform_Access;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Tx : out Qt4.Q_Real;
     Ty : out Qt4.Q_Real);
   pragma Import (C, QTransform_map_qreal_qreal_qrealP_qrealP, "__QtAda_QTransform_map_qreal_qreal_qrealP_qrealP_Q");

   procedure QTransform_map_int_int_intP_intP
    (Self : Internals.QTransform_Access;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     Tx : out Qt4.Q_Integer;
     Ty : out Qt4.Q_Integer);
   pragma Import (C, QTransform_map_int_int_intP_intP, "__QtAda_QTransform_map_int_int_intP_intP_Q");

   procedure QTransform_map_QPointCR
    (Returns : Qt4.Points.Internals.QPoint_Access;
     Self : Internals.QTransform_Access;
     P : Qt4.Points.Internals.QPoint_Access);
   pragma Import (C, QTransform_map_QPointCR, "__QtAda_QTransform_map_QPointCR_Q");

   procedure QTransform_map_QPointFCR
    (Returns : Qt4.Point_Fs.Internals.QPointF_Access;
     Self : Internals.QTransform_Access;
     P : Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QTransform_map_QPointFCR, "__QtAda_QTransform_map_QPointFCR_Q");

   procedure QTransform_map_QLineCR
    (Returns : Qt4.Lines.Internals.QLine_Access;
     Self : Internals.QTransform_Access;
     P : Qt4.Lines.Internals.QLine_Access);
   pragma Import (C, QTransform_map_QLineCR, "__QtAda_QTransform_map_QLineCR_Q");

   procedure QTransform_map_QLineFCR
    (Returns : Qt4.Line_Fs.Internals.QLineF_Access;
     Self : Internals.QTransform_Access;
     P : Qt4.Line_Fs.Internals.QLineF_Access);
   pragma Import (C, QTransform_map_QLineFCR, "__QtAda_QTransform_map_QLineFCR_Q");

   procedure QTransform_map_QPolygonCR
    (Returns : Qt4.Polygons.Internals.QPolygon_Access;
     Self : Internals.QTransform_Access;
     P : Qt4.Polygons.Internals.QPolygon_Access);
   pragma Import (C, QTransform_map_QPolygonCR, "__QtAda_QTransform_map_QPolygonCR_Q");

   procedure QTransform_map_QPolygonFCR
    (Returns : Qt4.Polygon_Fs.Internals.QPolygonF_Access;
     Self : Internals.QTransform_Access;
     P : Qt4.Polygon_Fs.Internals.QPolygonF_Access);
   pragma Import (C, QTransform_map_QPolygonFCR, "__QtAda_QTransform_map_QPolygonFCR_Q");

   procedure QTransform_map_QRegionCR
    (Returns : Qt4.Regions.Internals.QRegion_Access;
     Self : Internals.QTransform_Access;
     P : Qt4.Regions.Internals.QRegion_Access);
   pragma Import (C, QTransform_map_QRegionCR, "__QtAda_QTransform_map_QRegionCR_Q");

--   procedure QTransform_map_QPainterPathCR
--    (Returns : Qt4.Painter_Paths.Internals.QPainterPath_Access;
--     Self : Internals.QTransform_Access;
--     P : Qt4.Painter_Paths.Internals.QPainterPath_Access);
--   pragma Import (C, QTransform_map_QPainterPathCR, "__QtAda_QTransform_map_QPainterPathCR_Q");

   procedure QTransform_mapRect_QRectCR
    (Returns : Qt4.Rects.Internals.QRect_Access;
     Self : Internals.QTransform_Access;
     P : Qt4.Rects.Internals.QRect_Access);
   pragma Import (C, QTransform_mapRect_QRectCR, "__QtAda_QTransform_mapRect_QRectCR_Q");

   procedure QTransform_mapRect_QRectFCR
    (Returns : Qt4.Rect_Fs.Internals.QRectF_Access;
     Self : Internals.QTransform_Access;
     P : Qt4.Rect_Fs.Internals.QRectF_Access);
   pragma Import (C, QTransform_mapRect_QRectFCR, "__QtAda_QTransform_mapRect_QRectFCR_Q");

   procedure QTransform_mapToPolygon_QRectCR
    (Returns : Qt4.Polygons.Internals.QPolygon_Access;
     Self : Internals.QTransform_Access;
     P : Qt4.Rects.Internals.QRect_Access);
   pragma Import (C, QTransform_mapToPolygon_QRectCR, "__QtAda_QTransform_mapToPolygon_QRectCR_Q");

   procedure QTransform_reset
    (Self : Internals.QTransform_Access);
   pragma Import (C, QTransform_reset, "__QtAda_QTransform_reset");

   procedure QTransform_rotate_qreal_Axis
    (Self : Internals.QTransform_Access;
     A : Qt4.Q_Real;
     Axis : Qt4.Axis);
   pragma Import (C, QTransform_rotate_qreal_Axis, "__QtAda_QTransform_rotate_qreal_Axis");

   procedure QTransform_rotateRadians_qreal_Axis
    (Self : Internals.QTransform_Access;
     A : Qt4.Q_Real;
     Axis : Qt4.Axis);
   pragma Import (C, QTransform_rotateRadians_qreal_Axis, "__QtAda_QTransform_rotateRadians_qreal_Axis");

   procedure QTransform_scale_qreal_qreal
    (Self : Internals.QTransform_Access;
     Sx : Qt4.Q_Real;
     Sy : Qt4.Q_Real);
   pragma Import (C, QTransform_scale_qreal_qreal, "__QtAda_QTransform_scale_qreal_qreal");

   procedure QTransform_setMatrix_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal
    (Self : Internals.QTransform_Access;
     M_11 : Qt4.Q_Real;
     M_12 : Qt4.Q_Real;
     M_13 : Qt4.Q_Real;
     M_21 : Qt4.Q_Real;
     M_22 : Qt4.Q_Real;
     M_23 : Qt4.Q_Real;
     M_31 : Qt4.Q_Real;
     M_32 : Qt4.Q_Real;
     M_33 : Qt4.Q_Real);
   pragma Import (C, QTransform_setMatrix_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal, "__QtAda_QTransform_setMatrix_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal");

   procedure QTransform_shear_qreal_qreal
    (Self : Internals.QTransform_Access;
     Sh : Qt4.Q_Real;
     Sv : Qt4.Q_Real);
   pragma Import (C, QTransform_shear_qreal_qreal, "__QtAda_QTransform_shear_qreal_qreal");

   procedure QTransform_toAffine
    (Returns : Qt4.Matrices.Internals.QMatrix_Access;
     Self : Internals.QTransform_Access);
   pragma Import (C, QTransform_toAffine, "__QtAda_QTransform_toAffine_Q");

   procedure QTransform_translate_qreal_qreal
    (Self : Internals.QTransform_Access;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real);
   pragma Import (C, QTransform_translate_qreal_qreal, "__QtAda_QTransform_translate_qreal_qreal");

   procedure QTransform_transposed
    (Returns : Internals.QTransform_Access;
     Self : Internals.QTransform_Access);
   pragma Import (C, QTransform_transposed, "__QtAda_QTransform_transposed_Q");

   function eq_QTransformCR
    (Self : Internals.QTransform_Access;
     Matrix : Internals.QTransform_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, eq_QTransformCR, "__QtAda_QTransform_eq_QTransformCR_Q");

   procedure multiplication_QTransformCR
    (Returns : Internals.QTransform_Access;
     Self : Internals.QTransform_Access;
     O : Internals.QTransform_Access);
   pragma Import (C, multiplication_QTransformCR, "__QtAda_QTransform_multiplication_QTransformCR_Q");

   procedure multiplication_QPointCR_QTransformCR
    (Returns : Qt4.Points.Internals.QPoint_Access;
     P : Qt4.Points.Internals.QPoint_Access;
     M : Internals.QTransform_Access);
   pragma Import (C, multiplication_QPointCR_QTransformCR, "__QtAda_multiplication_QPointCR_QTransformCR");

   procedure multiplication_QPointFCR_QTransformCR
    (Returns : Qt4.Point_Fs.Internals.QPointF_Access;
     P : Qt4.Point_Fs.Internals.QPointF_Access;
     M : Internals.QTransform_Access);
   pragma Import (C, multiplication_QPointFCR_QTransformCR, "__QtAda_multiplication_QPointFCR_QTransformCR");

   procedure multiplication_QLineCR_QTransformCR
    (Returns : Qt4.Lines.Internals.QLine_Access;
     P : Qt4.Lines.Internals.QLine_Access;
     M : Internals.QTransform_Access);
   pragma Import (C, multiplication_QLineCR_QTransformCR, "__QtAda_multiplication_QLineCR_QTransformCR");

   procedure multiplication_QLineFCR_QTransformCR
    (Returns : Qt4.Line_Fs.Internals.QLineF_Access;
     P : Qt4.Line_Fs.Internals.QLineF_Access;
     M : Internals.QTransform_Access);
   pragma Import (C, multiplication_QLineFCR_QTransformCR, "__QtAda_multiplication_QLineFCR_QTransformCR");

   procedure multiplication_QPolygonCR_QTransformCR
    (Returns : Qt4.Polygons.Internals.QPolygon_Access;
     P : Qt4.Polygons.Internals.QPolygon_Access;
     M : Internals.QTransform_Access);
   pragma Import (C, multiplication_QPolygonCR_QTransformCR, "__QtAda_multiplication_QPolygonCR_QTransformCR");

   procedure multiplication_QPolygonFCR_QTransformCR
    (Returns : Qt4.Polygon_Fs.Internals.QPolygonF_Access;
     P : Qt4.Polygon_Fs.Internals.QPolygonF_Access;
     M : Internals.QTransform_Access);
   pragma Import (C, multiplication_QPolygonFCR_QTransformCR, "__QtAda_multiplication_QPolygonFCR_QTransformCR");

   procedure multiplication_QRegionCR_QTransformCR
    (Returns : Qt4.Regions.Internals.QRegion_Access;
     P : Qt4.Regions.Internals.QRegion_Access;
     M : Internals.QTransform_Access);
   pragma Import (C, multiplication_QRegionCR_QTransformCR, "__QtAda_multiplication_QRegionCR_QTransformCR");

--   procedure multiplication_QPainterPathCR_QTransformCR
--    (Returns : Qt4.Painter_Paths.Internals.QPainterPath_Access;
--     P : Qt4.Painter_Paths.Internals.QPainterPath_Access;
--     M : Internals.QTransform_Access);
--   pragma Import (C, multiplication_QPainterPathCR_QTransformCR, "__QtAda_multiplication_QPainterPathCR_QTransformCR");

   procedure multiplication_QTransformCR_qreal
    (Returns : Internals.QTransform_Access;
     A : Internals.QTransform_Access;
     N : Qt4.Q_Real);
   pragma Import (C, multiplication_QTransformCR_qreal, "__QtAda_multiplication_QTransformCR_qreal");

   procedure division_QTransformCR_qreal
    (Returns : Internals.QTransform_Access;
     A : Internals.QTransform_Access;
     N : Qt4.Q_Real);
   pragma Import (C, division_QTransformCR_qreal, "__QtAda_division_QTransformCR_qreal");

   procedure plus_QTransformCR_qreal
    (Returns : Internals.QTransform_Access;
     A : Internals.QTransform_Access;
     N : Qt4.Q_Real);
   pragma Import (C, plus_QTransformCR_qreal, "__QtAda_plus_QTransformCR_qreal");

   procedure minus_QTransformCR_qreal
    (Returns : Internals.QTransform_Access;
     A : Internals.QTransform_Access;
     N : Qt4.Q_Real);
   pragma Import (C, minus_QTransformCR_qreal, "__QtAda_minus_QTransformCR_qreal");

   ------------
   -- Adjust --
   ------------

   overriding
   procedure Adjust (Self : in out Q_Transform) is
   begin
      Self.Object := adjust_QTransform (Self.Storage'Address, Self.Object);
      Self.Wrapper := False;
   end Adjust;

   --------------
   -- Finalize --
   --------------

   overriding
   procedure Finalize (Self : in out Q_Transform) is
   begin
      if not Self.Wrapper then
         finalize_QTransform (Self.Object);
      end if;
   end Finalize;

   ----------------
   -- Initialize --
   ----------------

   overriding
   procedure Initialize (Self : in out Q_Transform) is
      use type Internals.QTransform_Access;

   begin
      if Self.Object = null then
         Self.Object := initialize_QTransform (Self.Storage'Address);
      end if;
   end Initialize;

   ------------
   -- Create --
   ------------

   function Create
    (H_11 : Qt4.Q_Real;
     H_12 : Qt4.Q_Real;
     H_13 : Qt4.Q_Real;
     H_21 : Qt4.Q_Real;
     H_22 : Qt4.Q_Real;
     H_23 : Qt4.Q_Real;
     H_31 : Qt4.Q_Real;
     H_32 : Qt4.Q_Real;
     H_33 : Qt4.Q_Real)
       return Q_Transform
   is
   begin
      return Self : Q_Transform
        := (Ada.Finalization.Controlled with others => <>)
      do
         Self.Object := initialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal (Self.Storage'Address, H_11, H_12, H_13, H_21, H_22, H_23, H_31, H_32, H_33);
      end return;
   end Create;

   ------------
   -- Create --
   ------------

   function Create
    (H_11 : Qt4.Q_Real;
     H_12 : Qt4.Q_Real;
     H_21 : Qt4.Q_Real;
     H_22 : Qt4.Q_Real;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real)
       return Q_Transform
   is
   begin
      return Self : Q_Transform
        := (Ada.Finalization.Controlled with others => <>)
      do
         Self.Object := initialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal (Self.Storage'Address, H_11, H_12, H_21, H_22, Dx, Dy);
      end return;
   end Create;

   ------------
   -- Create --
   ------------

   function Create
    (Tx : Qt4.Matrices.Q_Matrix'Class)
       return Q_Transform
   is
   begin
      return Self : Q_Transform
        := (Ada.Finalization.Controlled with others => <>)
      do
         Self.Object := initialize_QTransform_QMatrixCR (Self.Storage'Address, Qt4.Matrices.Internals.QMatrix_View (Tx));
      end return;
   end Create;

   ----------
   -- M_11 --
   ----------

   function M_11
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_m11 (Self.Object);
   end M_11;

   ----------
   -- M_12 --
   ----------

   function M_12
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_m12 (Self.Object);
   end M_12;

   ----------
   -- M_13 --
   ----------

   function M_13
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_m13 (Self.Object);
   end M_13;

   ----------
   -- M_21 --
   ----------

   function M_21
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_m21 (Self.Object);
   end M_21;

   ----------
   -- M_22 --
   ----------

   function M_22
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_m22 (Self.Object);
   end M_22;

   ----------
   -- M_23 --
   ----------

   function M_23
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_m23 (Self.Object);
   end M_23;

   ----------
   -- M_31 --
   ----------

   function M_31
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_m31 (Self.Object);
   end M_31;

   ----------
   -- M_32 --
   ----------

   function M_32
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_m32 (Self.Object);
   end M_32;

   ----------
   -- M_33 --
   ----------

   function M_33
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_m33 (Self.Object);
   end M_33;

   -------------
   -- Adjoint --
   -------------

   function Adjoint
    (Self : Q_Transform'Class)
       return Q_Transform
   is
   begin
      return Returns : Q_Transform do
         QTransform_adjoint (Returns.Object, Self.Object);
      end return;
   end Adjoint;

   ---------
   -- Det --
   ---------

   function Det
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_det (Self.Object);
   end Det;

   -----------------
   -- Determinant --
   -----------------

   function Determinant
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_determinant (Self.Object);
   end Determinant;

   --------
   -- Dx --
   --------

   function Dx
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_dx (Self.Object);
   end Dx;

   --------
   -- Dy --
   --------

   function Dy
    (Self : Q_Transform'Class)
       return Qt4.Q_Real
   is
   begin
      return QTransform_dy (Self.Object);
   end Dy;

   --------------
   -- Inverted --
   --------------

   function Inverted
    (Self : Q_Transform'Class)
       return Q_Transform
   is
   begin
      return Returns : Q_Transform do
         QTransform_inverted (Returns.Object, Self.Object);
      end return;
   end Inverted;

   ---------------
   -- Is_Affine --
   ---------------

   function Is_Affine
    (Self : Q_Transform'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QTransform_isAffine (Self.Object), 0);
   end Is_Affine;

   -----------------
   -- Is_Identity --
   -----------------

   function Is_Identity
    (Self : Q_Transform'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QTransform_isIdentity (Self.Object), 0);
   end Is_Identity;

   -------------------
   -- Is_Invertible --
   -------------------

   function Is_Invertible
    (Self : Q_Transform'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QTransform_isInvertible (Self.Object), 0);
   end Is_Invertible;

   -----------------
   -- Is_Rotating --
   -----------------

   function Is_Rotating
    (Self : Q_Transform'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QTransform_isRotating (Self.Object), 0);
   end Is_Rotating;

   ----------------
   -- Is_Scaling --
   ----------------

   function Is_Scaling
    (Self : Q_Transform'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QTransform_isScaling (Self.Object), 0);
   end Is_Scaling;

   --------------------
   -- Is_Translating --
   --------------------

   function Is_Translating
    (Self : Q_Transform'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QTransform_isTranslating (Self.Object), 0);
   end Is_Translating;

   ---------
   -- Map --
   ---------

   procedure Map
    (Self : Q_Transform'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Tx : out Qt4.Q_Real;
     Ty : out Qt4.Q_Real)
   is
   begin
      QTransform_map_qreal_qreal_qrealP_qrealP (Self.Object, X, Y, Tx, Ty);
   end Map;

   ---------
   -- Map --
   ---------

   procedure Map
    (Self : Q_Transform'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     Tx : out Qt4.Q_Integer;
     Ty : out Qt4.Q_Integer)
   is
   begin
      QTransform_map_int_int_intP_intP (Self.Object, X, Y, Tx, Ty);
   end Map;

   ---------
   -- Map --
   ---------

   function Map
    (Self : Q_Transform'Class;
     P : Qt4.Points.Q_Point'Class)
       return Qt4.Points.Q_Point
   is
   begin
      return Returns : Qt4.Points.Q_Point do
         QTransform_map_QPointCR (Qt4.Points.Internals.QPoint_View (Returns), Self.Object, Qt4.Points.Internals.QPoint_View (P));
      end return;
   end Map;

   ---------
   -- Map --
   ---------

   function Map
    (Self : Q_Transform'Class;
     P : Qt4.Point_Fs.Q_Point_F'Class)
       return Qt4.Point_Fs.Q_Point_F
   is
   begin
      return Returns : Qt4.Point_Fs.Q_Point_F do
         QTransform_map_QPointFCR (Qt4.Point_Fs.Internals.QPointF_View (Returns), Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
      end return;
   end Map;

   ---------
   -- Map --
   ---------

   function Map
    (Self : Q_Transform'Class;
     P : Qt4.Lines.Q_Line'Class)
       return Qt4.Lines.Q_Line
   is
   begin
      return Returns : Qt4.Lines.Q_Line do
         QTransform_map_QLineCR (Qt4.Lines.Internals.QLine_View (Returns), Self.Object, Qt4.Lines.Internals.QLine_View (P));
      end return;
   end Map;

   ---------
   -- Map --
   ---------

   function Map
    (Self : Q_Transform'Class;
     P : Qt4.Line_Fs.Q_Line_F'Class)
       return Qt4.Line_Fs.Q_Line_F
   is
   begin
      return Returns : Qt4.Line_Fs.Q_Line_F do
         QTransform_map_QLineFCR (Qt4.Line_Fs.Internals.QLineF_View (Returns), Self.Object, Qt4.Line_Fs.Internals.QLineF_View (P));
      end return;
   end Map;

   ---------
   -- Map --
   ---------

   function Map
    (Self : Q_Transform'Class;
     P : Qt4.Polygons.Q_Polygon'Class)
       return Qt4.Polygons.Q_Polygon
   is
   begin
      return Returns : Qt4.Polygons.Q_Polygon do
         QTransform_map_QPolygonCR (Qt4.Polygons.Internals.QPolygon_View (Returns), Self.Object, Qt4.Polygons.Internals.QPolygon_View (P));
      end return;
   end Map;

   ---------
   -- Map --
   ---------

   function Map
    (Self : Q_Transform'Class;
     P : Qt4.Polygon_Fs.Q_Polygon_F'Class)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
   begin
      return Returns : Qt4.Polygon_Fs.Q_Polygon_F do
         QTransform_map_QPolygonFCR (Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns), Self.Object, Qt4.Polygon_Fs.Internals.QPolygonF_View (P));
      end return;
   end Map;

   ---------
   -- Map --
   ---------

   function Map
    (Self : Q_Transform'Class;
     P : Qt4.Regions.Q_Region'Class)
       return Qt4.Regions.Q_Region
   is
   begin
      return Returns : Qt4.Regions.Q_Region do
         QTransform_map_QRegionCR (Qt4.Regions.Internals.QRegion_View (Returns), Self.Object, Qt4.Regions.Internals.QRegion_View (P));
      end return;
   end Map;

   ---------
   -- Map --
   ---------

--   function Map
--    (Self : Q_Transform'Class;
--     P : Qt4.Painter_Paths.Q_Painter_Path'Class)
--       return Qt4.Painter_Paths.Q_Painter_Path
--   is
--   begin
--      return Returns : Qt4.Painter_Paths.Q_Painter_Path do
--         QTransform_map_QPainterPathCR (Qt4.Painter_Paths.Internals.QPainterPath_View (Returns), Self.Object, Qt4.Painter_Paths.Internals.QPainterPath_View (P));
--      end return;
--   end Map;

   --------------
   -- Map_Rect --
   --------------

   function Map_Rect
    (Self : Q_Transform'Class;
     P : Qt4.Rects.Q_Rect'Class)
       return Qt4.Rects.Q_Rect
   is
   begin
      return Returns : Qt4.Rects.Q_Rect do
         QTransform_mapRect_QRectCR (Qt4.Rects.Internals.QRect_View (Returns), Self.Object, Qt4.Rects.Internals.QRect_View (P));
      end return;
   end Map_Rect;

   --------------
   -- Map_Rect --
   --------------

   function Map_Rect
    (Self : Q_Transform'Class;
     P : Qt4.Rect_Fs.Q_Rect_F'Class)
       return Qt4.Rect_Fs.Q_Rect_F
   is
   begin
      return Returns : Qt4.Rect_Fs.Q_Rect_F do
         QTransform_mapRect_QRectFCR (Qt4.Rect_Fs.Internals.QRectF_View (Returns), Self.Object, Qt4.Rect_Fs.Internals.QRectF_View (P));
      end return;
   end Map_Rect;

   --------------------
   -- Map_To_Polygon --
   --------------------

   function Map_To_Polygon
    (Self : Q_Transform'Class;
     P : Qt4.Rects.Q_Rect'Class)
       return Qt4.Polygons.Q_Polygon
   is
   begin
      return Returns : Qt4.Polygons.Q_Polygon do
         QTransform_mapToPolygon_QRectCR (Qt4.Polygons.Internals.QPolygon_View (Returns), Self.Object, Qt4.Rects.Internals.QRect_View (P));
      end return;
   end Map_To_Polygon;

   -----------
   -- Reset --
   -----------

   procedure Reset
    (Self : in out Q_Transform'Class)
   is
   begin
      QTransform_reset (Self.Object);
   end Reset;

   ------------
   -- Rotate --
   ------------

   procedure Rotate
    (Self : in out Q_Transform'Class;
     A : Qt4.Q_Real;
     Axis : Qt4.Axis
       := Z_Axis)
   is
   begin
      QTransform_rotate_qreal_Axis (Self.Object, A, Axis);
   end Rotate;

   --------------------
   -- Rotate_Radians --
   --------------------

   procedure Rotate_Radians
    (Self : in out Q_Transform'Class;
     A : Qt4.Q_Real;
     Axis : Qt4.Axis
       := Z_Axis)
   is
   begin
      QTransform_rotateRadians_qreal_Axis (Self.Object, A, Axis);
   end Rotate_Radians;

   -----------
   -- Scale --
   -----------

   procedure Scale
    (Self : in out Q_Transform'Class;
     Sx : Qt4.Q_Real;
     Sy : Qt4.Q_Real)
   is
   begin
      QTransform_scale_qreal_qreal (Self.Object, Sx, Sy);
   end Scale;

   ----------------
   -- Set_Matrix --
   ----------------

   procedure Set_Matrix
    (Self : in out Q_Transform'Class;
     M_11 : Qt4.Q_Real;
     M_12 : Qt4.Q_Real;
     M_13 : Qt4.Q_Real;
     M_21 : Qt4.Q_Real;
     M_22 : Qt4.Q_Real;
     M_23 : Qt4.Q_Real;
     M_31 : Qt4.Q_Real;
     M_32 : Qt4.Q_Real;
     M_33 : Qt4.Q_Real)
   is
   begin
      QTransform_setMatrix_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal (Self.Object, M_11, M_12, M_13, M_21, M_22, M_23, M_31, M_32, M_33);
   end Set_Matrix;

   -----------
   -- Shear --
   -----------

   procedure Shear
    (Self : in out Q_Transform'Class;
     Sh : Qt4.Q_Real;
     Sv : Qt4.Q_Real)
   is
   begin
      QTransform_shear_qreal_qreal (Self.Object, Sh, Sv);
   end Shear;

   ---------------
   -- To_Affine --
   ---------------

   function To_Affine
    (Self : Q_Transform'Class)
       return Qt4.Matrices.Q_Matrix
   is
   begin
      return Returns : Qt4.Matrices.Q_Matrix do
         QTransform_toAffine (Qt4.Matrices.Internals.QMatrix_View (Returns), Self.Object);
      end return;
   end To_Affine;

   ---------------
   -- Translate --
   ---------------

   procedure Translate
    (Self : in out Q_Transform'Class;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real)
   is
   begin
      QTransform_translate_qreal_qreal (Self.Object, Dx, Dy);
   end Translate;

   ----------------
   -- Transposed --
   ----------------

   function Transposed
    (Self : Q_Transform'Class)
       return Q_Transform
   is
   begin
      return Returns : Q_Transform do
         QTransform_transposed (Returns.Object, Self.Object);
      end return;
   end Transposed;

   ---------
   -- "=" --
   ---------

   function "="
    (Self : Q_Transform;
     Matrix : Q_Transform)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (eq_QTransformCR (Self.Object, Matrix.Object), 0);
   end "=";

   ---------
   -- "*" --
   ---------

   function "*"
    (Self : Q_Transform;
     O : Q_Transform)
       return Q_Transform
   is
   begin
      return Returns : Q_Transform do
         multiplication_QTransformCR (Returns.Object, Self.Object, O.Object);
      end return;
   end "*";

   ---------
   -- "*" --
   ---------

   function "*"
    (P : Qt4.Points.Q_Point'Class;
     M : Q_Transform)
       return Qt4.Points.Q_Point
   is
   begin
      return Returns : Qt4.Points.Q_Point do
         multiplication_QPointCR_QTransformCR (Qt4.Points.Internals.QPoint_View (Returns), Qt4.Points.Internals.QPoint_View (P), M.Object);
      end return;
   end "*";

   ---------
   -- "*" --
   ---------

   function "*"
    (P : Qt4.Point_Fs.Q_Point_F'Class;
     M : Q_Transform)
       return Qt4.Point_Fs.Q_Point_F
   is
   begin
      return Returns : Qt4.Point_Fs.Q_Point_F do
         multiplication_QPointFCR_QTransformCR (Qt4.Point_Fs.Internals.QPointF_View (Returns), Qt4.Point_Fs.Internals.QPointF_View (P), M.Object);
      end return;
   end "*";

   ---------
   -- "*" --
   ---------

   function "*"
    (P : Qt4.Lines.Q_Line'Class;
     M : Q_Transform)
       return Qt4.Lines.Q_Line
   is
   begin
      return Returns : Qt4.Lines.Q_Line do
         multiplication_QLineCR_QTransformCR (Qt4.Lines.Internals.QLine_View (Returns), Qt4.Lines.Internals.QLine_View (P), M.Object);
      end return;
   end "*";

   ---------
   -- "*" --
   ---------

   function "*"
    (P : Qt4.Line_Fs.Q_Line_F'Class;
     M : Q_Transform)
       return Qt4.Line_Fs.Q_Line_F
   is
   begin
      return Returns : Qt4.Line_Fs.Q_Line_F do
         multiplication_QLineFCR_QTransformCR (Qt4.Line_Fs.Internals.QLineF_View (Returns), Qt4.Line_Fs.Internals.QLineF_View (P), M.Object);
      end return;
   end "*";

   ---------
   -- "*" --
   ---------

   function "*"
    (P : Qt4.Polygons.Q_Polygon'Class;
     M : Q_Transform)
       return Qt4.Polygons.Q_Polygon
   is
   begin
      return Returns : Qt4.Polygons.Q_Polygon do
         multiplication_QPolygonCR_QTransformCR (Qt4.Polygons.Internals.QPolygon_View (Returns), Qt4.Polygons.Internals.QPolygon_View (P), M.Object);
      end return;
   end "*";

   ---------
   -- "*" --
   ---------

   function "*"
    (P : Qt4.Polygon_Fs.Q_Polygon_F'Class;
     M : Q_Transform)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
   begin
      return Returns : Qt4.Polygon_Fs.Q_Polygon_F do
         multiplication_QPolygonFCR_QTransformCR (Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns), Qt4.Polygon_Fs.Internals.QPolygonF_View (P), M.Object);
      end return;
   end "*";

   ---------
   -- "*" --
   ---------

   function "*"
    (P : Qt4.Regions.Q_Region'Class;
     M : Q_Transform)
       return Qt4.Regions.Q_Region
   is
   begin
      return Returns : Qt4.Regions.Q_Region do
         multiplication_QRegionCR_QTransformCR (Qt4.Regions.Internals.QRegion_View (Returns), Qt4.Regions.Internals.QRegion_View (P), M.Object);
      end return;
   end "*";

   ---------
   -- "*" --
   ---------

--   function "*"
--    (P : Qt4.Painter_Paths.Q_Painter_Path'Class;
--     M : Q_Transform)
--       return Qt4.Painter_Paths.Q_Painter_Path
--   is
--   begin
--      return Returns : Qt4.Painter_Paths.Q_Painter_Path do
--         multiplication_QPainterPathCR_QTransformCR (Qt4.Painter_Paths.Internals.QPainterPath_View (Returns), Qt4.Painter_Paths.Internals.QPainterPath_View (P), M.Object);
--      end return;
--   end "*";

   ---------
   -- "*" --
   ---------

   function "*"
    (A : Q_Transform;
     N : Qt4.Q_Real)
       return Q_Transform
   is
   begin
      return Returns : Q_Transform do
         multiplication_QTransformCR_qreal (Returns.Object, A.Object, N);
      end return;
   end "*";

   ---------
   -- "/" --
   ---------

   function "/"
    (A : Q_Transform;
     N : Qt4.Q_Real)
       return Q_Transform
   is
   begin
      return Returns : Q_Transform do
         division_QTransformCR_qreal (Returns.Object, A.Object, N);
      end return;
   end "/";

   ---------
   -- "+" --
   ---------

   function "+"
    (A : Q_Transform;
     N : Qt4.Q_Real)
       return Q_Transform
   is
   begin
      return Returns : Q_Transform do
         plus_QTransformCR_qreal (Returns.Object, A.Object, N);
      end return;
   end "+";

   ---------
   -- "-" --
   ---------

   function "-"
    (A : Q_Transform;
     N : Qt4.Q_Real)
       return Q_Transform
   is
   begin
      return Returns : Q_Transform do
         minus_QTransformCR_qreal (Returns.Object, A.Object, N);
      end return;
   end "-";

   ---------------
   -- Internals --
   ---------------

   package body Internals is

   ---------------------
   -- QTransform_View --
   ---------------------

      function QTransform_View
       (Item : Q_Transform'Class)
          return QTransform_Access
      is
      begin
         return Item.Object;
      end QTransform_View;

      package QTransform_Conversions is
        new System.Address_To_Access_Conversions
             (QTransform);

   --------------------------
   -- QTransformTo_Pointer --
   --------------------------

      function To_Pointer
       (Address : System.Address)
          return QTransform_Access
      is
      begin
         return
           QTransform_Access
            (QTransform_Conversions.To_Pointer
            (Address));
      end To_Pointer;

   --------------------------
   -- QTransformTo_Address --
   --------------------------

      function To_Address
       (Pointer : QTransform_Access)
          return System.Address
      is
      begin
         return
           QTransform_Conversions.To_Address
            (QTransform_Conversions.Object_Pointer
              (Pointer));
      end To_Address;

   --------------------
   -- Create_Wrapper --
   --------------------

      function Create_Wrapper
       (Item : Internals.QTransform_Access)
          return Q_Transform
      is
      begin
         return Q_Transform'
          (Ada.Finalization.Controlled with
             Object  => Item,
             Wrapper => True,
             others  => <>);
      end Create_Wrapper;

   end Internals;

end Qt4.Transforms;
